diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/kses.php ./wordpress-3.4/wp-includes/kses.php
*** ./wordpress-3.3.2/wp-includes/kses.php	2012-04-19 16:52:24.000000000 -0500
--- ./wordpress-3.4/wp-includes/kses.php	2012-06-01 15:47:08.000000000 -0500
***************
*** 10,16 ****
   *
   * This program is distributed in the hope that it will be useful, but WITHOUT
   * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
!  * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
   * more details.
   *
   * You should have received a copy of the GNU General Public License along
--- 10,16 ----
   *
   * This program is distributed in the hope that it will be useful, but WITHOUT
   * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
!  * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
   * more details.
   *
   * You should have received a copy of the GNU General Public License along
***************
*** 51,398 ****
  	$allowedposttags = array(
  		'address' => array(),
  		'a' => array(
! 			'class' => array (),
! 			'href' => array (),
! 			'id' => array (),
! 			'title' => array (),
! 			'rel' => array (),
! 			'rev' => array (),
! 			'name' => array (),
! 			'target' => array()),
  		'abbr' => array(
! 			'class' => array (),
! 			'title' => array ()),
  		'acronym' => array(
! 			'title' => array ()),
  		'article' => array(
! 			'align' => array (),
! 			'class' => array (),
! 			'dir' => array (),
! 			'lang' => array(),
! 			'style' => array (),
! 			'xml:lang' => array(),
  		),
  		'aside' => array(
! 			'align' => array (),
! 			'class' => array (),
! 			'dir' => array (),
! 			'lang' => array(),
! 			'style' => array (),
! 			'xml:lang' => array(),
  		),
  		'b' => array(),
  		'big' => array(),
  		'blockquote' => array(
! 			'id' => array (),
! 			'cite' => array (),
! 			'class' => array(),
! 			'lang' => array(),
! 			'xml:lang' => array()),
  		'br' => array (
! 			'class' => array ()),
  		'button' => array(
! 			'disabled' => array (),
! 			'name' => array (),
! 			'type' => array (),
! 			'value' => array ()),
  		'caption' => array(
! 			'align' => array (),
! 			'class' => array ()),
  		'cite' => array (
! 			'class' => array(),
! 			'dir' => array(),
! 			'lang' => array(),
! 			'title' => array ()),
  		'code' => array (
! 			'style' => array()),
  		'col' => array(
! 			'align' => array (),
! 			'char' => array (),
! 			'charoff' => array (),
! 			'span' => array (),
! 			'dir' => array(),
! 			'style' => array (),
! 			'valign' => array (),
! 			'width' => array ()),
  		'del' => array(
! 			'datetime' => array ()),
  		'dd' => array(),
  		'details' => array(
! 			'align' => array (),
! 			'class' => array (),
! 			'dir' => array (),
! 			'lang' => array(),
! 			'open' => array (),
! 			'style' => array (),
! 			'xml:lang' => array(),
  		),
  		'div' => array(
! 			'align' => array (),
! 			'class' => array (),
! 			'dir' => array (),
! 			'lang' => array(),
! 			'style' => array (),
! 			'xml:lang' => array()),
  		'dl' => array(),
  		'dt' => array(),
  		'em' => array(),
  		'fieldset' => array(),
  		'figure' => array(
! 			'align' => array (),
! 			'class' => array (),
! 			'dir' => array (),
! 			'lang' => array(),
! 			'style' => array (),
! 			'xml:lang' => array(),
  		),
  		'figcaption' => array(
! 			'align' => array (),
! 			'class' => array (),
! 			'dir' => array (),
! 			'lang' => array(),
! 			'style' => array (),
! 			'xml:lang' => array(),
  		),
  		'font' => array(
! 			'color' => array (),
! 			'face' => array (),
! 			'size' => array ()),
  		'footer' => array(
! 			'align' => array (),
! 			'class' => array (),
! 			'dir' => array (),
! 			'lang' => array(),
! 			'style' => array (),
! 			'xml:lang' => array(),
  		),
  		'form' => array(
! 			'action' => array (),
! 			'accept' => array (),
! 			'accept-charset' => array (),
! 			'enctype' => array (),
! 			'method' => array (),
! 			'name' => array (),
! 			'target' => array ()),
  		'h1' => array(
! 			'align' => array (),
! 			'class' => array (),
! 			'id'    => array (),
! 			'style' => array ()),
  		'h2' => array (
! 			'align' => array (),
! 			'class' => array (),
! 			'id'    => array (),
! 			'style' => array ()),
  		'h3' => array (
! 			'align' => array (),
! 			'class' => array (),
! 			'id'    => array (),
! 			'style' => array ()),
  		'h4' => array (
! 			'align' => array (),
! 			'class' => array (),
! 			'id'    => array (),
! 			'style' => array ()),
  		'h5' => array (
! 			'align' => array (),
! 			'class' => array (),
! 			'id'    => array (),
! 			'style' => array ()),
  		'h6' => array (
! 			'align' => array (),
! 			'class' => array (),
! 			'id'    => array (),
! 			'style' => array ()),
  		'header' => array(
! 			'align' => array (),
! 			'class' => array (),
! 			'dir' => array (),
! 			'lang' => array(),
! 			'style' => array (),
! 			'xml:lang' => array(),
  		),
  		'hgroup' => array(
! 			'align' => array (),
! 			'class' => array (),
! 			'dir' => array (),
! 			'lang' => array(),
! 			'style' => array (),
! 			'xml:lang' => array(),
  		),
  		'hr' => array (
! 			'align' => array (),
! 			'class' => array (),
! 			'noshade' => array (),
! 			'size' => array (),
! 			'width' => array ()),
  		'i' => array(),
  		'img' => array(
! 			'alt' => array (),
! 			'align' => array (),
! 			'border' => array (),
! 			'class' => array (),
! 			'height' => array (),
! 			'hspace' => array (),
! 			'longdesc' => array (),
! 			'vspace' => array (),
! 			'src' => array (),
! 			'style' => array (),
! 			'width' => array ()),
  		'ins' => array(
! 			'datetime' => array (),
! 			'cite' => array ()),
  		'kbd' => array(),
  		'label' => array(
! 			'for' => array ()),
  		'legend' => array(
! 			'align' => array ()),
  		'li' => array (
! 			'align' => array (),
! 			'class' => array ()),
  		'menu' => array (
! 			'class' => array (),
! 			'style' => array (),
! 			'type' => array ()),
  		'nav' => array(
! 			'align' => array (),
! 			'class' => array (),
! 			'dir' => array (),
! 			'lang' => array(),
! 			'style' => array (),
! 			'xml:lang' => array(),
  		),
  		'p' => array(
! 			'class' => array (),
! 			'align' => array (),
! 			'dir' => array(),
! 			'lang' => array(),
! 			'style' => array (),
! 			'xml:lang' => array()),
  		'pre' => array(
! 			'style' => array(),
! 			'width' => array ()),
  		'q' => array(
! 			'cite' => array ()),
  		's' => array(),
  		'span' => array (
! 			'class' => array (),
! 			'dir' => array (),
! 			'align' => array (),
! 			'lang' => array (),
! 			'style' => array (),
! 			'title' => array (),
! 			'xml:lang' => array()),
  		'section' => array(
! 			'align' => array (),
! 			'class' => array (),
! 			'dir' => array (),
! 			'lang' => array(),
! 			'style' => array (),
! 			'xml:lang' => array(),
  		),
  		'strike' => array(),
  		'strong' => array(),
  		'sub' => array(),
  		'summary' => array(
! 			'align' => array (),
! 			'class' => array (),
! 			'dir' => array (),
! 			'lang' => array(),
! 			'style' => array (),
! 			'xml:lang' => array(),
  		),
  		'sup' => array(),
  		'table' => array(
! 			'align' => array (),
! 			'bgcolor' => array (),
! 			'border' => array (),
! 			'cellpadding' => array (),
! 			'cellspacing' => array (),
! 			'class' => array (),
! 			'dir' => array(),
! 			'id' => array(),
! 			'rules' => array (),
! 			'style' => array (),
! 			'summary' => array (),
! 			'width' => array ()),
  		'tbody' => array(
! 			'align' => array (),
! 			'char' => array (),
! 			'charoff' => array (),
! 			'valign' => array ()),
  		'td' => array(
! 			'abbr' => array (),
! 			'align' => array (),
! 			'axis' => array (),
! 			'bgcolor' => array (),
! 			'char' => array (),
! 			'charoff' => array (),
! 			'class' => array (),
! 			'colspan' => array (),
! 			'dir' => array(),
! 			'headers' => array (),
! 			'height' => array (),
! 			'nowrap' => array (),
! 			'rowspan' => array (),
! 			'scope' => array (),
! 			'style' => array (),
! 			'valign' => array (),
! 			'width' => array ()),
  		'textarea' => array(
! 			'cols' => array (),
! 			'rows' => array (),
! 			'disabled' => array (),
! 			'name' => array (),
! 			'readonly' => array ()),
  		'tfoot' => array(
! 			'align' => array (),
! 			'char' => array (),
! 			'class' => array (),
! 			'charoff' => array (),
! 			'valign' => array ()),
  		'th' => array(
! 			'abbr' => array (),
! 			'align' => array (),
! 			'axis' => array (),
! 			'bgcolor' => array (),
! 			'char' => array (),
! 			'charoff' => array (),
! 			'class' => array (),
! 			'colspan' => array (),
! 			'headers' => array (),
! 			'height' => array (),
! 			'nowrap' => array (),
! 			'rowspan' => array (),
! 			'scope' => array (),
! 			'valign' => array (),
! 			'width' => array ()),
  		'thead' => array(
! 			'align' => array (),
! 			'char' => array (),
! 			'charoff' => array (),
! 			'class' => array (),
! 			'valign' => array ()),
  		'title' => array(),
  		'tr' => array(
! 			'align' => array (),
! 			'bgcolor' => array (),
! 			'char' => array (),
! 			'charoff' => array (),
! 			'class' => array (),
! 			'style' => array (),
! 			'valign' => array ()),
  		'tt' => array(),
  		'u' => array(),
  		'ul' => array (
! 			'class' => array (),
! 			'style' => array (),
! 			'type' => array ()),
  		'ol' => array (
! 			'class' => array (),
! 			'start' => array (),
! 			'style' => array (),
! 			'type' => array ()),
! 		'var' => array ());
  
  	/**
  	 * Kses allowed HTML elements.
--- 51,440 ----
  	$allowedposttags = array(
  		'address' => array(),
  		'a' => array(
! 			'class' => true,
! 			'href' => true,
! 			'id' => true,
! 			'title' => true,
! 			'rel' => true,
! 			'rev' => true,
! 			'name' => true,
! 			'target' => true,
! 		),
  		'abbr' => array(
! 			'class' => true,
! 			'title' => true,
! 		),
  		'acronym' => array(
! 			'title' => true,
! 		),
  		'article' => array(
! 			'align' => true,
! 			'class' => true,
! 			'dir' => true,
! 			'lang' => true,
! 			'style' => true,
! 			'xml:lang' => true,
  		),
  		'aside' => array(
! 			'align' => true,
! 			'class' => true,
! 			'dir' => true,
! 			'lang' => true,
! 			'style' => true,
! 			'xml:lang' => true,
  		),
  		'b' => array(),
  		'big' => array(),
  		'blockquote' => array(
! 			'id' => true,
! 			'cite' => true,
! 			'class' => true,
! 			'lang' => true,
! 			'xml:lang' => true,
! 		),
  		'br' => array (
! 			'class' => true,
! 		),
  		'button' => array(
! 			'disabled' => true,
! 			'name' => true,
! 			'type' => true,
! 			'value' => true,
! 		),
  		'caption' => array(
! 			'align' => true,
! 			'class' => true,
! 		),
  		'cite' => array (
! 			'class' => true,
! 			'dir' => true,
! 			'lang' => true,
! 			'title' => true,
! 		),
  		'code' => array (
! 			'style' => true,
! 		),
  		'col' => array(
! 			'align' => true,
! 			'char' => true,
! 			'charoff' => true,
! 			'span' => true,
! 			'dir' => true,
! 			'style' => true,
! 			'valign' => true,
! 			'width' => true,
! 		),
  		'del' => array(
! 			'datetime' => true,
! 		),
  		'dd' => array(),
  		'details' => array(
! 			'align' => true,
! 			'class' => true,
! 			'dir' => true,
! 			'lang' => true,
! 			'open' => true,
! 			'style' => true,
! 			'xml:lang' => true,
  		),
  		'div' => array(
! 			'align' => true,
! 			'class' => true,
! 			'dir' => true,
! 			'lang' => true,
! 			'style' => true,
! 			'xml:lang' => true,
! 		),
  		'dl' => array(),
  		'dt' => array(),
  		'em' => array(),
  		'fieldset' => array(),
  		'figure' => array(
! 			'align' => true,
! 			'class' => true,
! 			'dir' => true,
! 			'lang' => true,
! 			'style' => true,
! 			'xml:lang' => true,
  		),
  		'figcaption' => array(
! 			'align' => true,
! 			'class' => true,
! 			'dir' => true,
! 			'lang' => true,
! 			'style' => true,
! 			'xml:lang' => true,
  		),
  		'font' => array(
! 			'color' => true,
! 			'face' => true,
! 			'size' => true,
! 		),
  		'footer' => array(
! 			'align' => true,
! 			'class' => true,
! 			'dir' => true,
! 			'lang' => true,
! 			'style' => true,
! 			'xml:lang' => true,
  		),
  		'form' => array(
! 			'action' => true,
! 			'accept' => true,
! 			'accept-charset' => true,
! 			'enctype' => true,
! 			'method' => true,
! 			'name' => true,
! 			'target' => true,
! 		),
  		'h1' => array(
! 			'align' => true,
! 			'class' => true,
! 			'id'    => true,
! 			'style' => true,
! 		),
  		'h2' => array (
! 			'align' => true,
! 			'class' => true,
! 			'id'    => true,
! 			'style' => true,
! 		),
  		'h3' => array (
! 			'align' => true,
! 			'class' => true,
! 			'id'    => true,
! 			'style' => true,
! 		),
  		'h4' => array (
! 			'align' => true,
! 			'class' => true,
! 			'id'    => true,
! 			'style' => true,
! 		),
  		'h5' => array (
! 			'align' => true,
! 			'class' => true,
! 			'id'    => true,
! 			'style' => true,
! 		),
  		'h6' => array (
! 			'align' => true,
! 			'class' => true,
! 			'id'    => true,
! 			'style' => true,
! 		),
  		'header' => array(
! 			'align' => true,
! 			'class' => true,
! 			'dir' => true,
! 			'lang' => true,
! 			'style' => true,
! 			'xml:lang' => true,
  		),
  		'hgroup' => array(
! 			'align' => true,
! 			'class' => true,
! 			'dir' => true,
! 			'lang' => true,
! 			'style' => true,
! 			'xml:lang' => true,
  		),
  		'hr' => array (
! 			'align' => true,
! 			'class' => true,
! 			'noshade' => true,
! 			'size' => true,
! 			'width' => true,
! 		),
  		'i' => array(),
  		'img' => array(
! 			'alt' => true,
! 			'align' => true,
! 			'border' => true,
! 			'class' => true,
! 			'height' => true,
! 			'hspace' => true,
! 			'longdesc' => true,
! 			'vspace' => true,
! 			'src' => true,
! 			'style' => true,
! 			'width' => true,
! 		),
  		'ins' => array(
! 			'datetime' => true,
! 			'cite' => true,
! 		),
  		'kbd' => array(),
  		'label' => array(
! 			'for' => true,
! 		),
  		'legend' => array(
! 			'align' => true,
! 		),
  		'li' => array (
! 			'align' => true,
! 			'class' => true,
! 		),
  		'menu' => array (
! 			'class' => true,
! 			'style' => true,
! 			'type' => true,
! 		),
  		'nav' => array(
! 			'align' => true,
! 			'class' => true,
! 			'dir' => true,
! 			'lang' => true,
! 			'style' => true,
! 			'xml:lang' => true,
  		),
  		'p' => array(
! 			'class' => true,
! 			'align' => true,
! 			'dir' => true,
! 			'lang' => true,
! 			'style' => true,
! 			'xml:lang' => true,
! 		),
  		'pre' => array(
! 			'style' => true,
! 			'width' => true,
! 		),
  		'q' => array(
! 			'cite' => true,
! 		),
  		's' => array(),
  		'span' => array (
! 			'class' => true,
! 			'dir' => true,
! 			'align' => true,
! 			'lang' => true,
! 			'style' => true,
! 			'title' => true,
! 			'xml:lang' => true,
! 		),
  		'section' => array(
! 			'align' => true,
! 			'class' => true,
! 			'dir' => true,
! 			'lang' => true,
! 			'style' => true,
! 			'xml:lang' => true,
  		),
  		'strike' => array(),
  		'strong' => array(),
  		'sub' => array(),
  		'summary' => array(
! 			'align' => true,
! 			'class' => true,
! 			'dir' => true,
! 			'lang' => true,
! 			'style' => true,
! 			'xml:lang' => true,
  		),
  		'sup' => array(),
  		'table' => array(
! 			'align' => true,
! 			'bgcolor' => true,
! 			'border' => true,
! 			'cellpadding' => true,
! 			'cellspacing' => true,
! 			'class' => true,
! 			'dir' => true,
! 			'id' => true,
! 			'rules' => true,
! 			'style' => true,
! 			'summary' => true,
! 			'width' => true,
! 		),
  		'tbody' => array(
! 			'align' => true,
! 			'char' => true,
! 			'charoff' => true,
! 			'valign' => true,
! 		),
  		'td' => array(
! 			'abbr' => true,
! 			'align' => true,
! 			'axis' => true,
! 			'bgcolor' => true,
! 			'char' => true,
! 			'charoff' => true,
! 			'class' => true,
! 			'colspan' => true,
! 			'dir' => true,
! 			'headers' => true,
! 			'height' => true,
! 			'nowrap' => true,
! 			'rowspan' => true,
! 			'scope' => true,
! 			'style' => true,
! 			'valign' => true,
! 			'width' => true,
! 		),
  		'textarea' => array(
! 			'cols' => true,
! 			'rows' => true,
! 			'disabled' => true,
! 			'name' => true,
! 			'readonly' => true,
! 		),
  		'tfoot' => array(
! 			'align' => true,
! 			'char' => true,
! 			'class' => true,
! 			'charoff' => true,
! 			'valign' => true,
! 		),
  		'th' => array(
! 			'abbr' => true,
! 			'align' => true,
! 			'axis' => true,
! 			'bgcolor' => true,
! 			'char' => true,
! 			'charoff' => true,
! 			'class' => true,
! 			'colspan' => true,
! 			'headers' => true,
! 			'height' => true,
! 			'nowrap' => true,
! 			'rowspan' => true,
! 			'scope' => true,
! 			'valign' => true,
! 			'width' => true,
! 		),
  		'thead' => array(
! 			'align' => true,
! 			'char' => true,
! 			'charoff' => true,
! 			'class' => true,
! 			'valign' => true,
! 		),
  		'title' => array(),
  		'tr' => array(
! 			'align' => true,
! 			'bgcolor' => true,
! 			'char' => true,
! 			'charoff' => true,
! 			'class' => true,
! 			'style' => true,
! 			'valign' => true,
! 		),
  		'tt' => array(),
  		'u' => array(),
  		'ul' => array (
! 			'class' => true,
! 			'style' => true,
! 			'type' => true,
! 		),
  		'ol' => array (
! 			'class' => true,
! 			'start' => true,
! 			'style' => true,
! 			'type' => true,
! 		),
! 		'var' => array(),
! 	);
  
  	/**
  	 * Kses allowed HTML elements.
***************
*** 402,421 ****
  	 */
  	$allowedtags = array(
  		'a' => array(
! 			'href' => array (),
! 			'title' => array ()),
  		'abbr' => array(
! 			'title' => array ()),
  		'acronym' => array(
! 			'title' => array ()),
  		'b' => array(),
  		'blockquote' => array(
! 			'cite' => array ()),
  		//	'br' => array(),
! 		'cite' => array (),
  		'code' => array(),
  		'del' => array(
! 			'datetime' => array ()),
  		//	'dd' => array(),
  		//	'dl' => array(),
  		//	'dt' => array(),
--- 444,468 ----
  	 */
  	$allowedtags = array(
  		'a' => array(
! 			'href' => true,
! 			'title' => true,
! 		),
  		'abbr' => array(
! 			'title' => true,
! 		),
  		'acronym' => array(
! 			'title' => true,
! 		),
  		'b' => array(),
  		'blockquote' => array(
! 			'cite' => true,
! 		),
  		//	'br' => array(),
! 		'cite' => array(),
  		'code' => array(),
  		'del' => array(
! 			'datetime' => true,
! 		),
  		//	'dd' => array(),
  		//	'dl' => array(),
  		//	'dt' => array(),
***************
*** 425,431 ****
  		//	'ol' => array(),
  		//	'p' => array(),
  		'q' => array(
! 			'cite' => array ()),
  		'strike' => array(),
  		'strong' => array(),
  		//	'sub' => array(),
--- 472,479 ----
  		//	'ol' => array(),
  		//	'p' => array(),
  		'q' => array(
! 			'cite' => true,
! 		),
  		'strike' => array(),
  		'strong' => array(),
  		//	'sub' => array(),
***************
*** 674,679 ****
--- 722,738 ----
  		if ( $current == '' )
  			continue; # the attribute is not allowed
  
+ 		if ( strtolower( $arreach['name'] ) == 'style' ) {
+ 			$orig_value = $arreach['value'];
+ 			$value = safecss_filter_attr( $orig_value );
+ 
+ 			if ( empty( $value ) )
+ 				continue;
+ 
+ 			$arreach['value'] = $value;
+ 			$arreach['whole'] = str_replace( $orig_value, $value, $arreach['whole'] );
+ 		}
+ 
  		if ( ! is_array($current) ) {
  			$attr2 .= ' '.$arreach['whole'];
  		# there are no checks
***************
*** 688,705 ****
  				}
  			}
  
! 			if ( strtolower($arreach['name']) == 'style' ) {
! 				$orig_value = $arreach['value'];
! 				$value = safecss_filter_attr($orig_value);
! 
! 				if ( empty($value) )
! 					continue;
! 
! 				$arreach['value'] = $value;
! 				$arreach['whole'] = str_replace($orig_value, $value, $arreach['whole']);
! 			}
! 
! 			if ($ok)
  				$attr2 .= ' '.$arreach['whole']; # it passed them
  		} # if !is_array($current)
  	} # foreach
--- 747,753 ----
  				}
  			}
  
! 			if ( $ok )
  				$attr2 .= ' '.$arreach['whole']; # it passed them
  		} # if !is_array($current)
  	} # foreach
***************
*** 718,724 ****
   * input. It will add quotes around attribute values that don't have any quotes
   * or apostrophes around them, to make it easier to produce HTML code that will
   * conform to W3C's HTML specification. It will also remove bad URL protocols
!  * from attribute values.  It also reduces duplicate attributes by using the
   * attribute defined first (foo='bar' foo='baz' will result in foo='bar').
   *
   * @since 1.0.0
--- 766,772 ----
   * input. It will add quotes around attribute values that don't have any quotes
   * or apostrophes around them, to make it easier to produce HTML code that will
   * conform to W3C's HTML specification. It will also remove bad URL protocols
!  * from attribute values. It also reduces duplicate attributes by using the
   * attribute defined first (foo='bar' foo='baz' will result in foo='bar').
   *
   * @since 1.0.0
***************
*** 763,769 ****
  					{
  					$working = 1;
  					$mode = 0;
! 					if(FALSE === array_key_exists($attrname, $attrarr)) {
  						$attrarr[$attrname] = array ('name' => $attrname, 'value' => '', 'whole' => $attrname, 'vless' => 'y');
  					}
  					$attr = preg_replace('/^\s+/', '', $attr);
--- 811,817 ----
  					{
  					$working = 1;
  					$mode = 0;
! 					if(false === array_key_exists($attrname, $attrarr)) {
  						$attrarr[$attrname] = array ('name' => $attrname, 'value' => '', 'whole' => $attrname, 'vless' => 'y');
  					}
  					$attr = preg_replace('/^\s+/', '', $attr);
***************
*** 780,786 ****
  					if ( in_array(strtolower($attrname), $uris) )
  						$thisval = wp_kses_bad_protocol($thisval, $allowed_protocols);
  
! 					if(FALSE === array_key_exists($attrname, $attrarr)) {
  						$attrarr[$attrname] = array ('name' => $attrname, 'value' => $thisval, 'whole' => "$attrname=\"$thisval\"", 'vless' => 'n');
  					}
  					$working = 1;
--- 828,834 ----
  					if ( in_array(strtolower($attrname), $uris) )
  						$thisval = wp_kses_bad_protocol($thisval, $allowed_protocols);
  
! 					if(false === array_key_exists($attrname, $attrarr)) {
  						$attrarr[$attrname] = array ('name' => $attrname, 'value' => $thisval, 'whole' => "$attrname=\"$thisval\"", 'vless' => 'n');
  					}
  					$working = 1;
***************
*** 796,802 ****
  					if ( in_array(strtolower($attrname), $uris) )
  						$thisval = wp_kses_bad_protocol($thisval, $allowed_protocols);
  
! 					if(FALSE === array_key_exists($attrname, $attrarr)) {
  						$attrarr[$attrname] = array ('name' => $attrname, 'value' => $thisval, 'whole' => "$attrname='$thisval'", 'vless' => 'n');
  					}
  					$working = 1;
--- 844,850 ----
  					if ( in_array(strtolower($attrname), $uris) )
  						$thisval = wp_kses_bad_protocol($thisval, $allowed_protocols);
  
! 					if(false === array_key_exists($attrname, $attrarr)) {
  						$attrarr[$attrname] = array ('name' => $attrname, 'value' => $thisval, 'whole' => "$attrname='$thisval'", 'vless' => 'n');
  					}
  					$working = 1;
***************
*** 812,818 ****
  					if ( in_array(strtolower($attrname), $uris) )
  						$thisval = wp_kses_bad_protocol($thisval, $allowed_protocols);
  
! 					if(FALSE === array_key_exists($attrname, $attrarr)) {
  						$attrarr[$attrname] = array ('name' => $attrname, 'value' => $thisval, 'whole' => "$attrname=\"$thisval\"", 'vless' => 'n');
  					}
  					# We add quotes to conform to W3C's HTML spec.
--- 860,866 ----
  					if ( in_array(strtolower($attrname), $uris) )
  						$thisval = wp_kses_bad_protocol($thisval, $allowed_protocols);
  
! 					if(false === array_key_exists($attrname, $attrarr)) {
  						$attrarr[$attrname] = array ('name' => $attrname, 'value' => $thisval, 'whole' => "$attrname=\"$thisval\"", 'vless' => 'n');
  					}
  					# We add quotes to conform to W3C's HTML spec.
***************
*** 831,837 ****
  		}
  	} # while
  
! 	if ($mode == 1 && FALSE === array_key_exists($attrname, $attrarr))
  		# special case, for when the attribute list ends with a valueless
  		# attribute like "selected"
  		$attrarr[$attrname] = array ('name' => $attrname, 'value' => '', 'whole' => $attrname, 'vless' => 'y');
--- 879,885 ----
  		}
  	} # while
  
! 	if ($mode == 1 && false === array_key_exists($attrname, $attrarr))
  		# special case, for when the attribute list ends with a valueless
  		# attribute like "selected"
  		$attrarr[$attrname] = array ('name' => $attrname, 'value' => '', 'whole' => $attrname, 'vless' => 'y');
***************
*** 941,947 ****
  }
  
  /**
!  * Removes any NULL characters in $string.
   *
   * @since 1.0.0
   *
--- 989,995 ----
  }
  
  /**
!  * Removes any null characters in $string.
   *
   * @since 1.0.0
   *
***************
*** 1315,1324 ****
   * @uses add_filter() See description for what functions are added to what hooks.
   */
  function kses_init_filters() {
! 	// Normal filtering.
! 	add_filter('pre_comment_content', 'wp_filter_kses');
  	add_filter('title_save_pre', 'wp_filter_kses');
  
  	// Post filtering
  	add_filter('content_save_pre', 'wp_filter_post_kses');
  	add_filter('excerpt_save_pre', 'wp_filter_post_kses');
--- 1363,1377 ----
   * @uses add_filter() See description for what functions are added to what hooks.
   */
  function kses_init_filters() {
! 	// Normal filtering
  	add_filter('title_save_pre', 'wp_filter_kses');
  
+ 	// Comment filtering
+ 	if ( current_user_can( 'unfiltered_html' ) )
+ 		add_filter( 'pre_comment_content', 'wp_filter_post_kses' );
+ 	else
+ 		add_filter( 'pre_comment_content', 'wp_filter_kses' );
+ 
  	// Post filtering
  	add_filter('content_save_pre', 'wp_filter_post_kses');
  	add_filter('excerpt_save_pre', 'wp_filter_post_kses');
***************
*** 1338,1347 ****
   * @since 2.0.6
   */
  function kses_remove_filters() {
! 	// Normal filtering.
! 	remove_filter('pre_comment_content', 'wp_filter_kses');
  	remove_filter('title_save_pre', 'wp_filter_kses');
  
  	// Post filtering
  	remove_filter('content_save_pre', 'wp_filter_post_kses');
  	remove_filter('excerpt_save_pre', 'wp_filter_post_kses');
--- 1391,1403 ----
   * @since 2.0.6
   */
  function kses_remove_filters() {
! 	// Normal filtering
  	remove_filter('title_save_pre', 'wp_filter_kses');
  
+ 	// Comment filtering
+ 	remove_filter( 'pre_comment_content', 'wp_filter_post_kses' );
+ 	remove_filter( 'pre_comment_content', 'wp_filter_kses' );
+ 
  	// Post filtering
  	remove_filter('content_save_pre', 'wp_filter_post_kses');
  	remove_filter('excerpt_save_pre', 'wp_filter_post_kses');
***************
*** 1414,1420 ****
  		if ( strpos( $css_item, ':' ) === false ) {
  			$found = true;
  		} else {
! 			$parts = split( ':', $css_item );
  			if ( in_array( trim( $parts[0] ), $allowed_attr ) )
  				$found = true;
  		}
--- 1470,1476 ----
  		if ( strpos( $css_item, ':' ) === false ) {
  			$found = true;
  		} else {
! 			$parts = explode( ':', $css_item );
  			if ( in_array( trim( $parts[0] ), $allowed_attr ) )
  				$found = true;
  		}
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/l10n.php ./wordpress-3.4/wp-includes/l10n.php
*** ./wordpress-3.3.2/wp-includes/l10n.php	2011-10-25 00:09:03.000000000 -0500
--- ./wordpress-3.4/wp-includes/l10n.php	2012-05-14 12:58:06.000000000 -0500
***************
*** 272,281 ****
   * @since 2.5
   * @param string $singular Single form to be i18ned
   * @param string $plural Plural form to be i18ned
   * @return array array($singular, $plural)
   */
! function _n_noop( $singular, $plural ) {
! 	return array( 0 => $singular, 1 => $plural, 'singular' => $singular, 'plural' => $plural, 'context' => null );
  }
  
  /**
--- 272,282 ----
   * @since 2.5
   * @param string $singular Single form to be i18ned
   * @param string $plural Plural form to be i18ned
+  * @param string $domain Optional. The domain identifier the text will be retrieved in
   * @return array array($singular, $plural)
   */
! function _n_noop( $singular, $plural, $domain = null ) {
! 	return array( 0 => $singular, 1 => $plural, 'singular' => $singular, 'plural' => $plural, 'context' => null, 'domain' => $domain );
  }
  
  /**
***************
*** 283,290 ****
   *
   * @see _n_noop()
   */
! function _nx_noop( $singular, $plural, $context ) {
! 	return array( 0 => $singular, 1 => $plural, 2 => $context, 'singular' => $singular, 'plural' => $plural, 'context' => $context );
  }
  
  /**
--- 284,291 ----
   *
   * @see _n_noop()
   */
! function _nx_noop( $singular, $plural, $context, $domain = null ) {
! 	return array( 0 => $singular, 1 => $plural, 2 => $context, 'singular' => $singular, 'plural' => $plural, 'context' => $context, 'domain' => $domain );
  }
  
  /**
***************
*** 293,301 ****
   * @since 3.1
   * @param array $nooped_plural Array with singular, plural and context keys, usually the result of _n_noop() or _nx_noop()
   * @param int $count Number of objects
!  * @param string $domain Optional. The domain identifier the text should be retrieved in
   */
  function translate_nooped_plural( $nooped_plural, $count, $domain = 'default' ) {
  	if ( $nooped_plural['context'] )
  		return _nx( $nooped_plural['singular'], $nooped_plural['plural'], $count, $nooped_plural['context'], $domain );
  	else
--- 294,306 ----
   * @since 3.1
   * @param array $nooped_plural Array with singular, plural and context keys, usually the result of _n_noop() or _nx_noop()
   * @param int $count Number of objects
!  * @param string $domain Optional. The domain identifier the text should be retrieved in. If $nooped_plural contains
!  * 	a domain passed to _n_noop() or _nx_noop(), it will override this value.
   */
  function translate_nooped_plural( $nooped_plural, $count, $domain = 'default' ) {
+ 	if ( $nooped_plural['domain'] )
+ 		$domain = $nooped_plural['domain'];
+ 
  	if ( $nooped_plural['context'] )
  		return _nx( $nooped_plural['singular'], $nooped_plural['plural'], $count, $nooped_plural['context'], $domain );
  	else
***************
*** 382,390 ****
  
  	load_textdomain( 'default', WP_LANG_DIR . "/$locale.mo" );
  
! 	if ( is_multisite() || ( defined( 'WP_INSTALLING_NETWORK' ) && WP_INSTALLING_NETWORK ) ) {
  		load_textdomain( 'default', WP_LANG_DIR . "/ms-$locale.mo" );
  	}
  }
  
  /**
--- 387,403 ----
  
  	load_textdomain( 'default', WP_LANG_DIR . "/$locale.mo" );
  
! 	if ( ( is_multisite() || ( defined( 'WP_INSTALLING_NETWORK' ) && WP_INSTALLING_NETWORK ) ) && ! file_exists(  WP_LANG_DIR . "/admin-$locale.mo" ) ) {
  		load_textdomain( 'default', WP_LANG_DIR . "/ms-$locale.mo" );
+ 		return;
  	}
+ 
+ 	if ( is_admin()  )
+ 		load_textdomain( 'default', WP_LANG_DIR . "/admin-$locale.mo" );
+ 
+ 	if ( is_network_admin() || ( defined( 'WP_INSTALLING_NETWORK' ) && WP_INSTALLING_NETWORK ) )
+ 		load_textdomain( 'default', WP_LANG_DIR . "/admin-network-$locale.mo" );
+ 
  }
  
  /**
***************
*** 527,533 ****
  
  	foreach( (array)glob( ( is_null( $dir) ? WP_LANG_DIR : $dir ) . '/*.mo' ) as $lang_file ) {
  		$lang_file = basename($lang_file, '.mo');
! 		if ( 0 !== strpos( $lang_file, 'continents-cities' ) && 0 !== strpos( $lang_file, 'ms-' ) )
  			$languages[] = $lang_file;
  	}
  
--- 540,547 ----
  
  	foreach( (array)glob( ( is_null( $dir) ? WP_LANG_DIR : $dir ) . '/*.mo' ) as $lang_file ) {
  		$lang_file = basename($lang_file, '.mo');
! 		if ( 0 !== strpos( $lang_file, 'continents-cities' ) && 0 !== strpos( $lang_file, 'ms-' ) &&
! 			0 !== strpos( $lang_file, 'admin-' ))
  			$languages[] = $lang_file;
  	}
  
